unit Calcul;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    FunctionEdit: TEdit;
    UpBoundYEdit: TEdit;
    Label2: TLabel;
    LowBoundYEdit: TEdit;
    Label3: TLabel;
    UpBoundXEdit: TEdit;
    Label4: TLabel;
    LowBoundXEdit: TEdit;
    Label5: TLabel;
    StepsEdit: TEdit;
    Label6: TLabel;
    ValueEdit: TEdit;
    Label7: TLabel;
    ResultEdit: TEdit;
    Label8: TLabel;
    EvaluateButton: TButton;
    RootButton: TButton;
    DerivativeButton: TButton;
    IntegralButton: TButton;
    ImpIntegralButton: TButton;
    DoubleIntegralButton: TButton;
    ResetButton: TButton;
    procedure CalcFunction(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses AdvCalc;

{$R *.DFM}

procedure TForm1.CalcFunction(Sender: TObject);
var UserFunc, UpY, LowY: string;
    UpX, LowX, InValue, Y, StepSize: extended;
    Steps: integer;
begin
    UserFunc:= FunctionEdit.Text;
    UpY:= UpBoundYEdit.Text;
    LowY:= LowBoundYEdit.Text;
    UpX:= StrToFloat(UpBoundXEdit.Text);
    LowX:= StrToFloat(LowBoundXEdit.Text);
    Steps:= StrToInt(StepsEdit.Text);
    InValue:= StrToFloat(ValueEdit.Text);
    if Sender = EvaluateButton then
    Y:= FunctionValue(UserFunc, InValue) else
    if Sender = RootButton then
    Y:= FunctionRoot(UserFunc, InValue, Steps) else
    if Sender = IntegralButton then
    Y:= DefIntegral(UserFunc, UpX, LowX, Steps) else
    if Sender = ImpIntegralButton then
    Y:= ImproperIntegral(UserFunc, UpX, LowX, Steps) else
    if Sender = DoubleIntegralButton then
    Y:= DoubleIntegral(UserFunc, UpY, LowY, UpX, LowX, Steps) else
    if Sender = DerivativeButton then
    Y:= FirstDerivative(UserFunc, InValue, 1/Steps);
    ResultEdit.Text:= FloatToStr(Y);
end;

procedure TForm1.ResetButtonClick(Sender: TObject);
begin
    FunctionEdit.Text:= '0';
    UpBoundYEdit.Text:= '0';
    LowBoundYEdit.Text:= '0';
    UpBoundXEdit.Text:= '0';
    LowBoundXEdit.Text:= '0';
    StepsEdit.Text:= '0';
    ValueEdit.Text:= '0';
    ResultEdit.Text:= '0';
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
     ResetButtonClick(Sender);
end;

end.
